<!-- eslint-disable -->
<template>
  <div id="app">
    <header id="header">
      <div class="logo-form-search text-center">
        <router-link to="/">
          <img class="pt-3" src="./assets/sharebook-logo.png" alt="sharebook logo" />
        </router-link>
        <!-- Search Form -->
        <div id="autocom" class="mt-3">
          <!-- <div>
            <autocomplete
              :search="searchBooks"
              placeholder="Rechercher un livre"
              aria-label="Rechercher un livre"
              :get-result-value="getResultValueBooks"
              @submit="handleSubmitBooks"
            ></autocomplete>
          </div> -->
          <!-- <div>
            <autocomplete
              :search="searchAuthors"
              placeholder="Rechercher un auteur"
              aria-label="Rechercher un auteur"
              :get-result-value="getResultValueAuthors"
              @submit="handleSubmitAuthors"
            ></autocomplete>
          </div>
          <div>
            <autocomplete
              :search="searchCategories"
              placeholder="Rechercher une catégorie"
              aria-label="Rechercher une catégories"
              :get-result-value="getResultValueCategories"
              @submit="handleSubmitCategories"
            ></autocomplete>
          </div>-->
          <!-- End Search Form -->
        </div>
      </div>

      <nav id="nav-header">
        <ul class="row justify-content-around p-0">
          <li class="col-md-4 my-3">
            <router-link to="/">Accueil</router-link>
          </li>
          <li class="col-md-4 my-3">
            <router-link to="/all-books">Tous les livres</router-link>
          </li>
          <li class="col-md-4 my-3">
            <router-link to="/about">A Propos</router-link>
          </li>
        </ul>
      </nav>
    </header>
    <router-view />
    <footer id="footer" class="mt-5">
      <nav id="nav-footer">
        <ul class="row justify-content-around p-0 m-0">
          <li class="col-md-6 my-4">Galvan Melissa 2020 ©</li>
          <li class="col-md-6 my-4">Test</li>
        </ul>
      </nav>
    </footer>
  </div>
</template>

<script>
/* eslint-disable */
import Autocomplete from "@trevoreyre/autocomplete-vue";
import "@trevoreyre/autocomplete-vue/dist/style.css";
import BookService from "./services/BookService";
// import AuthorService from "./services/AuthorService";
// import CategoriesService from "./services/CategoriesService";

export default {
  components: {
    Autocomplete
    // SideBarVue
  },
  data() {
    return {
      books: [],
      // authors: [],
      // categories: []
    };
  },
  mounted() {
    const serviceBook = new BookService();
    // const serviceAuthor = new AuthorService();
    // const serviceCategories = new CategoriesService();

    serviceBook
      .findAll()
      .then(data => {
        this.books = data;
      })
      .catch(() => this.$router.push("/"));

    // serviceAuthor
    //   .findAll()
    //   .then(data => {
    //     this.authors = data;
    //   })
    //   .catch(() => this.$router.push("/"));

    // serviceCategories
    //   .findAll()
    //   .then(data => {
    //     this.categories = data;
    //   })
    //   .catch(() => this.$router.push("/"));
  },
  methods: {
    searchBooks(input) {
      if (input.length < 1) {
        return [];
      }
      return this.books.filter(book => {
        return book.title.toLowerCase().startsWith(input.toLowerCase());
      });
    },
    getResultValueBooks(result) {
      return result.title;
    },
    handleSubmitBooks(result) {
      window.open(`http://localhost:8080/one-book/${result.id}`);
    },

    // searchAuthors(input) {
    //   if (input.length < 1) {
    //     return [];
    //   }
    //   return this.authors.filter(author => {
    //     return author.fullname.toLowerCase().startsWith(input.toLowerCase());
    //   });
    // },
    // getResultValueAuthors(result) {
    //   return result.fullname;
    // },
    // handleSubmitAuthors(result) {
    //   window.open(`http://localhost:8080/one-author/${result.id}`);
    // },
    // searchCategories(input) {
    //   if (input.length < 1) {
    //     return [];
    //   }
    //   return this.categories.filter(category => {
    //     return category.title.toLowerCase().startsWith(input.toLowerCase());
    //   });
    // },
    // getResultValueCategories(result) {
    //   return result.title;
    // },
    // handleSubmitCategories(result) {
    //   window.open(`http://localhost:8080/one-category/${result.id}`);
    // }
  }
};
</script>

<style lang="scss">
#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #000000;

  a {
    outline: none;
  }
}

#autocom {
  max-width: 400px;
  margin: 0 auto;
}

#header {
  background-color: #385169;
  box-shadow: 1px 1px 10px #383838;

  #nav-header {
    ul {
      list-style: none;
    }

    img {
      height: 90px;
    }
    a {
      font-size: 15px;
      letter-spacing: 2px;
      color: #000000;
      text-decoration: none;
      text-transform: uppercase;

      &.router-link-exact-active {
        color: #c0c0c0;
      }
    }
    a:hover {
      transition-duration: 1.3s;
      color: #c0c0c0;
    }
  }
}

#footer {
  // height: 112px;
  background-color: #385169;
  box-shadow: 1px 1px 10px #383838;

  #nav-footer {
    ul {
      list-style: none;

      li {
        font-size: 15px;
        letter-spacing: 2px;
        text-transform: uppercase;
      }
    }
  }
}
</style>
